Index: /pjproject/branches/projects/jni/pjsip-apps/src/jni/AndroidManifest.xml
===================================================================
--- /pjproject/branches/projects/jni/pjsip-apps/src/jni/AndroidManifest.xml	(revision 4571)
+++ /pjproject/branches/projects/jni/pjsip-apps/src/jni/AndroidManifest.xml	(revision 4571)
@@ -0,0 +1,27 @@
+<?xml version="1.0" encoding="utf-8"?>
+<manifest xmlns:android="http://schemas.android.com/apk/res/android"
+    package="org.pjsip.hello"
+    android:versionCode="1"
+    android:versionName="1.0" >
+
+    <uses-sdk
+        android:minSdkVersion="8"
+        android:targetSdkVersion="17" />
+
+    <application
+        android:allowBackup="true"
+        android:icon="@drawable/ic_launcher"
+        android:label="@string/app_name"
+        android:theme="@style/AppTheme" >
+        <activity
+            android:name="org.pjsip.hello.MainActivity"
+            android:label="@string/app_name" >
+            <intent-filter>
+                <action android:name="android.intent.action.MAIN" />
+
+                <category android:name="android.intent.category.LAUNCHER" />
+            </intent-filter>
+        </activity>
+    </application>
+
+</manifest>
Index: /pjproject/branches/projects/jni/pjsip-apps/src/jni/jni/Android.mk
===================================================================
--- /pjproject/branches/projects/jni/pjsip-apps/src/jni/jni/Android.mk	(revision 4570)
+++ /pjproject/branches/projects/jni/pjsip-apps/src/jni/jni/Android.mk	(revision 4571)
@@ -61,5 +61,5 @@
 LOCAL_SRC_FILES := $(MY_SWIG_WRAPPER).cpp $(MY_OUT_DIR)/callbacks.cpp
 
-MY_JNI_WRAP	:= $(MY_SWIG_WRAPPER).cpp
+MY_JNI_WRAP	:= $(LOCAL_PATH)/$(MY_SWIG_WRAPPER).cpp
 
 jni: $(MY_JNI_LIB) java
@@ -99,4 +99,6 @@
 	$(MY_JAVA) -cp $(MY_PACKAGE_BIN) -Djava.library.path="$(MY_PACKAGE_BIN)" hello
 
+$(MY_JNI_WRAP): $(MY_SWIG_WRAPPER).cpp
+
 .PHONY: $(MY_JNI_WRAP)
 
Index: /pjproject/branches/projects/jni/pjsip-apps/src/jni/proguard-project.txt
===================================================================
--- /pjproject/branches/projects/jni/pjsip-apps/src/jni/proguard-project.txt	(revision 4571)
+++ /pjproject/branches/projects/jni/pjsip-apps/src/jni/proguard-project.txt	(revision 4571)
@@ -0,0 +1,20 @@
+# To enable ProGuard in your project, edit project.properties
+# to define the proguard.config property as described in that file.
+#
+# Add project specific ProGuard rules here.
+# By default, the flags in this file are appended to flags specified
+# in ${sdk.dir}/tools/proguard/proguard-android.txt
+# You can edit the include path and order by changing the ProGuard
+# include property in project.properties.
+#
+# For more details, see
+#   http://developer.android.com/guide/developing/tools/proguard.html
+
+# Add any project specific keep options here:
+
+# If your project uses WebView with JS, uncomment the following
+# and specify the fully qualified class name to the JavaScript interface
+# class:
+#-keepclassmembers class fqcn.of.javascript.interface.for.webview {
+#   public *;
+#}
Index: /pjproject/branches/projects/jni/pjsip-apps/src/jni/project.properties
===================================================================
--- /pjproject/branches/projects/jni/pjsip-apps/src/jni/project.properties	(revision 4571)
+++ /pjproject/branches/projects/jni/pjsip-apps/src/jni/project.properties	(revision 4571)
@@ -0,0 +1,14 @@
+# This file is automatically generated by Android Tools.
+# Do not modify this file -- YOUR CHANGES WILL BE ERASED!
+#
+# This file must be checked in Version Control Systems.
+#
+# To customize properties used by the Ant build system edit
+# "ant.properties", and override values to adapt the script to your
+# project structure.
+#
+# To enable ProGuard to shrink and obfuscate your code, uncomment this (available properties: sdk.dir, user.home):
+#proguard.config=${sdk.dir}/tools/proguard/proguard-android.txt:proguard-project.txt
+
+# Project target.
+target=android-17
Index: /pjproject/branches/projects/jni/pjsip-apps/src/jni/res/layout/activity_main.xml
===================================================================
--- /pjproject/branches/projects/jni/pjsip-apps/src/jni/res/layout/activity_main.xml	(revision 4571)
+++ /pjproject/branches/projects/jni/pjsip-apps/src/jni/res/layout/activity_main.xml	(revision 4571)
@@ -0,0 +1,16 @@
+<RelativeLayout xmlns:android="http://schemas.android.com/apk/res/android"
+    xmlns:tools="http://schemas.android.com/tools"
+    android:layout_width="match_parent"
+    android:layout_height="match_parent"
+    android:paddingBottom="@dimen/activity_vertical_margin"
+    android:paddingLeft="@dimen/activity_horizontal_margin"
+    android:paddingRight="@dimen/activity_horizontal_margin"
+    android:paddingTop="@dimen/activity_vertical_margin"
+    tools:context=".MainActivity" >
+
+    <TextView
+        android:layout_width="wrap_content"
+        android:layout_height="wrap_content"
+        android:text="@string/hello_world" />
+
+</RelativeLayout>
Index: /pjproject/branches/projects/jni/pjsip-apps/src/jni/res/menu/main.xml
===================================================================
--- /pjproject/branches/projects/jni/pjsip-apps/src/jni/res/menu/main.xml	(revision 4571)
+++ /pjproject/branches/projects/jni/pjsip-apps/src/jni/res/menu/main.xml	(revision 4571)
@@ -0,0 +1,9 @@
+<menu xmlns:android="http://schemas.android.com/apk/res/android" >
+
+    <item
+        android:id="@+id/action_settings"
+        android:orderInCategory="100"
+        android:showAsAction="never"
+        android:title="@string/action_settings"/>
+
+</menu>
Index: /pjproject/branches/projects/jni/pjsip-apps/src/jni/res/values-sw600dp/dimens.xml
===================================================================
--- /pjproject/branches/projects/jni/pjsip-apps/src/jni/res/values-sw600dp/dimens.xml	(revision 4571)
+++ /pjproject/branches/projects/jni/pjsip-apps/src/jni/res/values-sw600dp/dimens.xml	(revision 4571)
@@ -0,0 +1,8 @@
+<resources>
+
+    <!--
+         Customize dimensions originally defined in res/values/dimens.xml (such as
+         screen margins) for sw600dp devices (e.g. 7" tablets) here.
+    -->
+
+</resources>
Index: /pjproject/branches/projects/jni/pjsip-apps/src/jni/res/values-sw720dp-land/dimens.xml
===================================================================
--- /pjproject/branches/projects/jni/pjsip-apps/src/jni/res/values-sw720dp-land/dimens.xml	(revision 4571)
+++ /pjproject/branches/projects/jni/pjsip-apps/src/jni/res/values-sw720dp-land/dimens.xml	(revision 4571)
@@ -0,0 +1,9 @@
+<resources>
+
+    <!--
+         Customize dimensions originally defined in res/values/dimens.xml (such as
+         screen margins) for sw720dp devices (e.g. 10" tablets) in landscape here.
+    -->
+    <dimen name="activity_horizontal_margin">128dp</dimen>
+
+</resources>
Index: /pjproject/branches/projects/jni/pjsip-apps/src/jni/res/values-v11/styles.xml
===================================================================
--- /pjproject/branches/projects/jni/pjsip-apps/src/jni/res/values-v11/styles.xml	(revision 4571)
+++ /pjproject/branches/projects/jni/pjsip-apps/src/jni/res/values-v11/styles.xml	(revision 4571)
@@ -0,0 +1,11 @@
+<resources>
+
+    <!--
+        Base application theme for API 11+. This theme completely replaces
+        AppBaseTheme from res/values/styles.xml on API 11+ devices.
+    -->
+    <style name="AppBaseTheme" parent="android:Theme.Holo.Light">
+        <!-- API 11 theme customizations can go here. -->
+    </style>
+
+</resources>
Index: /pjproject/branches/projects/jni/pjsip-apps/src/jni/res/values-v14/styles.xml
===================================================================
--- /pjproject/branches/projects/jni/pjsip-apps/src/jni/res/values-v14/styles.xml	(revision 4571)
+++ /pjproject/branches/projects/jni/pjsip-apps/src/jni/res/values-v14/styles.xml	(revision 4571)
@@ -0,0 +1,12 @@
+<resources>
+
+    <!--
+        Base application theme for API 14+. This theme completely replaces
+        AppBaseTheme from BOTH res/values/styles.xml and
+        res/values-v11/styles.xml on API 14+ devices.
+    -->
+    <style name="AppBaseTheme" parent="android:Theme.Holo.Light.DarkActionBar">
+        <!-- API 14 theme customizations can go here. -->
+    </style>
+
+</resources>
Index: /pjproject/branches/projects/jni/pjsip-apps/src/jni/res/values/dimens.xml
===================================================================
--- /pjproject/branches/projects/jni/pjsip-apps/src/jni/res/values/dimens.xml	(revision 4571)
+++ /pjproject/branches/projects/jni/pjsip-apps/src/jni/res/values/dimens.xml	(revision 4571)
@@ -0,0 +1,7 @@
+<resources>
+
+    <!-- Default screen margins, per the Android Design guidelines. -->
+    <dimen name="activity_horizontal_margin">16dp</dimen>
+    <dimen name="activity_vertical_margin">16dp</dimen>
+
+</resources>
Index: /pjproject/branches/projects/jni/pjsip-apps/src/jni/res/values/strings.xml
===================================================================
--- /pjproject/branches/projects/jni/pjsip-apps/src/jni/res/values/strings.xml	(revision 4571)
+++ /pjproject/branches/projects/jni/pjsip-apps/src/jni/res/values/strings.xml	(revision 4571)
@@ -0,0 +1,8 @@
+<?xml version="1.0" encoding="utf-8"?>
+<resources>
+
+    <string name="app_name">hello</string>
+    <string name="action_settings">Settings</string>
+    <string name="hello_world">Hello world!</string>
+
+</resources>
Index: /pjproject/branches/projects/jni/pjsip-apps/src/jni/res/values/styles.xml
===================================================================
--- /pjproject/branches/projects/jni/pjsip-apps/src/jni/res/values/styles.xml	(revision 4571)
+++ /pjproject/branches/projects/jni/pjsip-apps/src/jni/res/values/styles.xml	(revision 4571)
@@ -0,0 +1,20 @@
+<resources>
+
+    <!--
+        Base application theme, dependent on API level. This theme is replaced
+        by AppBaseTheme from res/values-vXX/styles.xml on newer devices.
+    -->
+    <style name="AppBaseTheme" parent="android:Theme.Light">
+        <!--
+            Theme customizations available in newer API levels can go in
+            res/values-vXX/styles.xml, while customizations related to
+            backward-compatibility can go here.
+        -->
+    </style>
+
+    <!-- Application theme. -->
+    <style name="AppTheme" parent="AppBaseTheme">
+        <!-- All customizations that are NOT specific to a particular API-level can go here. -->
+    </style>
+
+</resources>
Index: /pjproject/branches/projects/jni/pjsip-apps/src/jni/src/org/pjsip/hello/MainActivity.java
===================================================================
--- /pjproject/branches/projects/jni/pjsip-apps/src/jni/src/org/pjsip/hello/MainActivity.java	(revision 4571)
+++ /pjproject/branches/projects/jni/pjsip-apps/src/jni/src/org/pjsip/hello/MainActivity.java	(revision 4571)
@@ -0,0 +1,22 @@
+package org.pjsip.hello;
+
+import android.os.Bundle;
+import android.app.Activity;
+import android.view.Menu;
+
+public class MainActivity extends Activity {
+
+	@Override
+	protected void onCreate(Bundle savedInstanceState) {
+		super.onCreate(savedInstanceState);
+		setContentView(R.layout.activity_main);
+	}
+
+	@Override
+	public boolean onCreateOptionsMenu(Menu menu) {
+		// Inflate the menu; this adds items to the action bar if it is present.
+		getMenuInflater().inflate(R.menu.main, menu);
+		return true;
+	}
+
+}