Index: pjproject/branches/projects/jni/pjsip-apps/src/jni/AndroidManifest.xml
===================================================================
--- pjproject/branches/projects/jni/pjsip-apps/src/jni/AndroidManifest.xml	(revision 4571)
+++ pjproject/branches/projects/jni/pjsip-apps/src/jni/AndroidManifest.xml	(revision 4574)
@@ -9,4 +9,23 @@
         android:targetSdkVersion="17" />
 
+    <uses-permission android:name="android.permission.INTERNET" />
+    <uses-permission android:name="android.permission.RECORD_AUDIO" />
+    <uses-permission android:name="android.permission.MODIFY_AUDIO_SETTINGS" />
+    <uses-permission android:name="android.permission.PROCESS_OUTGOING_CALLS" />
+    <uses-permission android:name="android.permission.WRITE_SETTINGS" />
+    <uses-permission android:name="android.permission.READ_PHONE_STATE" />
+    <uses-permission android:name="android.permission.ACCESS_WIFI_STATE" />
+    <uses-permission android:name="android.permission.ACCESS_NETWORK_STATE" />
+    <uses-permission android:name="android.permission.WAKE_LOCK" />
+    <uses-permission android:name="android.permission.VIBRATE" />
+    <uses-permission android:name="android.permission.READ_LOGS" />
+    <uses-permission android:name="android.permission.USE_SIP" />
+    <uses-permission android:name="android.permission.WRITE_EXTERNAL_STORAGE" />
+    <uses-permission android:name="android.permission.CAMERA" />
+
+    <uses-feature
+        android:name="android.hardware.microphone"
+        android:required="true" />
+   
     <application
         android:allowBackup="true"
Index: pjproject/branches/projects/jni/pjsip-apps/src/jni/Makefile
===================================================================
--- pjproject/branches/projects/jni/pjsip-apps/src/jni/Makefile	(revision 4571)
+++ pjproject/branches/projects/jni/pjsip-apps/src/jni/Makefile	(revision 4574)
@@ -1,1 +1,1 @@
-link jni/Android.mk
+include jni/Android.mk
Index: pjproject/branches/projects/jni/pjsip-apps/src/jni/jni/Android.mk
===================================================================
--- pjproject/branches/projects/jni/pjsip-apps/src/jni/jni/Android.mk	(revision 4571)
+++ pjproject/branches/projects/jni/pjsip-apps/src/jni/jni/Android.mk	(revision 4574)
@@ -53,5 +53,6 @@
 
 # Android build settings
-LOCAL_PATH	:= $(call my-dir)/pjsip-apps/src/jni
+LOCAL_PATH	:= $(PJDIR)/pjsip-apps/src/jni
+include $(CLEAR_VARS)
 LOCAL_MODULE    := libpjsua
 LOCAL_MODULE_FILENAME := libpjsua
@@ -60,6 +61,4 @@
 LOCAL_LDLIBS    := $(APP_LDLIBS)
 LOCAL_SRC_FILES := $(MY_SWIG_WRAPPER).cpp $(MY_OUT_DIR)/callbacks.cpp
-
-MY_JNI_WRAP	:= $(LOCAL_PATH)/$(MY_SWIG_WRAPPER).cpp
 
 jni: $(MY_JNI_LIB) java
@@ -99,7 +98,7 @@
 	$(MY_JAVA) -cp $(MY_PACKAGE_BIN) -Djava.library.path="$(MY_PACKAGE_BIN)" hello
 
-$(MY_JNI_WRAP): $(MY_SWIG_WRAPPER).cpp
+$(LOCAL_PATH)/$(MY_SWIG_WRAPPER).cpp: $(MY_SWIG_WRAPPER).cpp
 
-.PHONY: $(MY_JNI_WRAP)
+$(LOCAL_PATH)/$(MY_OUT_DIR)/callbacks.cpp: $(MY_OUT_DIR)/callbacks.cpp
 
 include $(BUILD_SHARED_LIBRARY)
Index: pjproject/branches/projects/jni/pjsip-apps/src/jni/jni/swig_gen.py
===================================================================
--- pjproject/branches/projects/jni/pjsip-apps/src/jni/jni/swig_gen.py	(revision 4571)
+++ pjproject/branches/projects/jni/pjsip-apps/src/jni/jni/swig_gen.py	(revision 4574)
@@ -22,5 +22,5 @@
 else:
     PYCPARSER_DIR="/Library/Python/2.7/site-packages/pycparser"
-    CPP_PATH='/Users/ming/teluu/android/android-ndk-r7c/toolchains/arm-linux-androideabi-4.4.3/prebuilt/darwin-x86/bin/arm-linux-androideabi-cpp'
+    CPP_PATH='/Users/ming/teluu/android/android-ndk-r8e/toolchains/arm-linux-androideabi-4.7/prebuilt/darwin-x86_64/bin/arm-linux-androideabi-cpp'
 
 # CPP (C preprocessor) settings
Index: pjproject/branches/projects/jni/pjsip-apps/src/jni/src/org/pjsip/hello/MainActivity.java
===================================================================
--- pjproject/branches/projects/jni/pjsip-apps/src/jni/src/org/pjsip/hello/MainActivity.java	(revision 4571)
+++ pjproject/branches/projects/jni/pjsip-apps/src/jni/src/org/pjsip/hello/MainActivity.java	(revision 4574)
@@ -11,4 +11,9 @@
 		super.onCreate(savedInstanceState);
 		setContentView(R.layout.activity_main);
+		
+		/* Call test app here
+		String [] args = {"sip:192.168.1.49"};
+		hello.main(args);
+		*/
 	}
 
Index: pjproject/branches/projects/jni/pjsip-apps/src/jni/src/org/pjsip/hello/hello.java
===================================================================
--- pjproject/branches/projects/jni/pjsip-apps/src/jni/src/org/pjsip/hello/hello.java	(revision 4571)
+++ pjproject/branches/projects/jni/pjsip-apps/src/jni/src/org/pjsip/hello/hello.java	(revision 4574)
@@ -1,3 +1,5 @@
 /* $Id: hello.java 4566 2013-07-17 20:20:50Z nanang $ */
+
+package org.pjsip.hello;
 
 import java.io.BufferedReader;